{% load static %}
<!DOCTYPE html>
<html>
<head>
	<meta name="copyright" content="Rechtsquellenstiftung des Schweizerischen Juristenvereins SSRQ, histHub" />
	<link rel="stylesheet" type="text/css" href="{% static '3rdparty/jquery-ui/1.12.1/jquery-ui.css' %}" />
	<link rel="stylesheet" type="text/css" href="{% static 'TM/css/stylesheet.css' %}" />
	<style type="text/css">
		html, body {
			height: 100%;
			min-width: 90em;
			position: fixed;
			width: 100%;
		}

		#titlebar {
			background-color: #696969;
			box-sizing: border-box;
			height: 5em;
			padding: 0.5em;
			position: fixed;
			width: 100%;

			-webkit-user-select: none;
			-moz-user-select: none;
			-ms-user-select: none;
			user-select: none;
		}

		div.control_row {
			height: 50%;
		}

		div#export_section {
			float: right;
		}
	</style>

	<script type="application/javascript" src="{% static '3rdparty/jquery/1.12.4/jquery.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/jquery-ui/1.12.1/jquery-ui.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/filesaver.js/1.3.2/FileSaver.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/ajv/6.5.2/ajv.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/x2js/1.2.0/xml2json.min.js' %}"></script>
	<script type="application/javascript" src="{% static '3rdparty/d3/3.5.17/d3.min.js' %}"></script>

	<script type="application/javascript" src="{% static 'TM/scripts/helper_scripts.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/ajax_csrf_token.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/d3_contextmenu.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/expandable_menu.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/save_to_file.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/json_xml_import.js' %}"></script>
	<script type="application/javascript" src="{% static 'TM/scripts/verticalTree.js' %}"></script>
	<script type="application/javascript">
		"use strict";

		var languages = JSON.parse("{{ languages|escapejs }}");
		var json_schema = JSON.parse("{{ json_schema|escapejs }}");

		/**
		 *  CookieManager is based on https://github.com/madmurphy/cookies.js
		 *
		 *  A complete cookies reader/writer framework with full unicode support.
		 *
		 *  Revision #3 - July 13th, 2017
		 *
		 *  https://developer.mozilla.org/en-US/docs/Web/API/document.cookie
		 *  https://developer.mozilla.org/User:fusionchess
		 *  https://github.com/madmurphy/cookies.js
		 *
		 *  This framework is released under the GNU Public License, version 3 or later.
		 *  http://www.gnu.org/licenses/gpl-3.0-standalone.html
		 */
		var CookieManager = {
			getItem: function (sKey) {
				if (!sKey) { return null; }
				return decodeURIComponent(document.cookie.replace(new RegExp("(?:(?:^|.*;)\\s*" + encodeURIComponent(sKey).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=\\s*([^;]*).*$)|^.*$"), "$1")) || null;
			},
			setItem: function (sKey, sValue, vEnd, sPath, sDomain, bSecure) {
				if (!sKey || /^(?:expires|max\-age|path|domain|secure)$/i.test(sKey)) { return false; }
				var sExpires = "";
				if (vEnd) {
					switch (vEnd.constructor) {
						case Number:
							sExpires = vEnd === Infinity ? "; expires=Fri, 31 Dec 9999 23:59:59 GMT" : "; expires=" + (new Date(vEnd * 1e3 + Date.now())).toUTCString();
							break;
						case String:
							sExpires = "; expires=" + vEnd;
							break;
						case Date:
							sExpires = "; expires=" + vEnd.toUTCString();
							break;
					}
				}
				document.cookie = encodeURIComponent(sKey) + "=" + encodeURIComponent(sValue) + sExpires + (sDomain ? "; domain=" + sDomain : "") + (sPath ? "; path=" + sPath : "") + (bSecure ? "; secure" : "");
				return true;
			},
			removeItem: function (sKey, sPath, sDomain) {
				if (!this.hasItem(sKey)) { return false; }
				document.cookie = encodeURIComponent(sKey) + "=; expires=Thu, 01 Jan 1970 00:00:00 GMT" + (sDomain ? "; domain=" + sDomain : "") + (sPath ? "; path=" + sPath : "");
				return true;
			},
			hasItem: function (sKey) {
				if (!sKey || /^(?:expires|max\-age|path|domain|secure)$/i.test(sKey)) { return false; }
				return (new RegExp("(?:^|;\\s*)" + encodeURIComponent(sKey).replace(/[\-\.\+\*]/g, "\\$&") + "\\s*\\=")).test(document.cookie);
			},
			keys: function () {
				var nIdx, nLen, aKeys = document.cookie.replace(/((?:^|\s*;)[^\=]+)(?=;|$)|^\s*|\s*(?:\=[^;]*)?(?:\1|$)/g, "").split(/\s*(?:\=[^;]*)?;\s*/);
				for (nLen = aKeys.length, nIdx = 0; nIdx < nLen; nIdx++) { aKeys[nIdx] = decodeURIComponent(aKeys[nIdx]); }
				return aKeys;
			}
		};

		$(function () {
			var $vocabSection = $("div#vocab_section");
			var $controlDiv = $("div#titlebar");
			var $panelDiv = $("div#panel");

			window.loadOtherVocabulary = function (value) {
				var $elem = value;
				if ("number" === typeof(value)) {
					$elem = $("#vocab_selection").find("option[value='"+value+"']");
				}
				if (0 === $elem.length || !$elem.data("url")) { return; }

				// Clear tree
				setStatus(load_status, "Vorgang gestartet...");
				$("div#tree-container").empty();

				// Update cookie and select vocabulary
				CookieManager.setItem("vocab_id", $elem.val());
				$elem.prop("selected", true);

				// Render new tree
				var newUrl = $elem.data("url");
				constructTree(
					newUrl, "#tree-container", load_status,
					getElementToDeactivate(), search_section, $languageSelect);
			};

			// Vocabulary management button
			{% if user.is_authenticated %}
			var $vocabManageButton = $("<button id='vocab_manage'>Thesauri verwalten</button>")
				.appendTo($vocabSection)
				.on("click", function () {
					function moveForward() {
						window.location = "{% url 'TM:vocab_list' %}";
					}
					var $selectedVocab = $vocabSelect.find("option:selected")
					if ($selectedVocab.length && $selectedVocab.data("vocab").modifiable) {
						getConfirmationBoxForSavingTree(moveForward);
					} else {
						moveForward();
					}
				});
			{% endif %}

			// Language selection
			var i, $languageSelect = $("<select/>");
			for (i = 0; i < languages.length; i++) {
				$("<option/>").attr("value", languages[i]).text(languages[i]).appendTo($languageSelect);
			}
			$("<div id='language'/>").append($languageSelect).prependTo($vocabSection);

			// Select user language
			var userLang = (CookieManager.getItem("preferred_language") || navigator.language || navigator.userLanguage);
			var compareFunctionList = [
				function (lang, userLang) { return lang === userLang; },
				function (lang, userLang) { return userLang.startsWith(lang); },
				function (lang, userLang) { return lang.substring(0, 2) === userLang.substring(0, 2); }
			];

			function testLanguageMatch(languages, userLang, $languageSelect, compareFunctionList) {
				var i = 0;
				var success = false;
				var compareFunction = compareFunctionList.shift();
				while (i < languages.length && !success) {
					if (compareFunction(languages[i].toLowerCase(), userLang.toLowerCase())) {
						$languageSelect.val(languages[i]);
						success = true;
					} else {
						i++;
					}
				}
				if (!success) {
					if (compareFunctionList.length) {
						testLanguageMatch(languages, userLang, $languageSelect, compareFunctionList);
					} else {
						$languageSelect.val("en");
					}
				}
			}

			testLanguageMatch(languages, userLang, $languageSelect, compareFunctionList);

			var status_board = $("<div id='status'/>").appendTo($controlDiv);

			// Export section
			var $exportExpandButton = createExportSection(
				$controlDiv.find($panelDiv), {% if user.is_authenticated %}true{% else %}false{% endif %});

			// Save button, AJAX call for tree modifications
			var $saveButton = $("<button id='save_button'>Speichern</button>")
				.hide().appendTo($panelDiv);
			$saveButton.on("click", function () {
				$("div#tree-container").empty();
				var elementsToDeactivate = getElementToDeactivate().deactivateWhileTreeConstructing;
				var switches = [];
				var n;
				for (n = 0; n < elementsToDeactivate.length; n++) {
					switches.push(controlElementActivation(elementsToDeactivate[n]));
				}
				search_section.children().remove();
				setStatus(status_board, "... wird gespeichert");
				saveTree(function (json) {
					if (json && json.success) {
						setStatus(status_board, "erfolgreich gespeichert", 100, false);
						// Refresh
						constructTree($vocabSelect.find("option:selected").data("url"), "#tree-container", load_status, getElementToDeactivate(), search_section, $languageSelect);
					} else {
						setStatus(status_board, "Speicherung fehlgeschlagen", 100, true);
					}
				}, function () {
					setStatus(status_board, "Speicherung fehlgeschlagen", 100, true);
				}, function () {
					switches.map(function (elem) {
						elem.resolve();
					});
				});
			});

			var load_status = $("<div id='load'></div>").appendTo($controlDiv);
			var search_section = $("div#search_section");

			// Discard changes
			var $resetButton = $("<button id='reset_button'>Änderungen verwerfen</button>")
				.hide().appendTo($panelDiv)
				.on("click", function (event) {
					var $selectedVocab = $vocabSelect.find("option:selected");
					if (0 < $selectedVocab.length) {
						setStatus(load_status, "Vorgang gestartet...");
						$("div#tree-container").empty();
						constructTree($selectedVocab.data("url"), "#tree-container", load_status, getElementToDeactivate(), search_section, $languageSelect);
					}
				});

			// Vocabulary selection
			var $vocabSelect = getVocabSelection("vocab_selection")
				.on("change", function () {
					loadOtherVocabulary($(this).find("option:selected"));
				}).prependTo($vocabSection);

			if ($vocabSelect.find("option").length > 0) {
				setStatus(load_status, "Vorgang gestartet...");
				constructTree($vocabSelect.find("option:selected").data("url"), "#tree-container", load_status, getElementToDeactivate(), search_section, $languageSelect);
				history.replaceState(null, "TM", "{% url 'TM:tree' %}");
			}

			// Elements to deactivate
			function getElementToDeactivate() {
				{% if user.is_authenticated %}
				return {
					deactivateWhileTreeConstructing: [$saveButton, $resetButton, $vocabSelect, $languageSelect, $vocabManageButton, $exportExpandButton],
					hideAndReactivateOnlyIfModifiable: [$saveButton, $resetButton]
				};
				{% else %}
				return {
					deactivateWhileTreeConstructing: [$saveButton, $resetButton, $vocabSelect, $languageSelect, $exportExpandButton],
					hideAndReactivateOnlyIfModifiable: [$saveButton, $resetButton]
				};
				{% endif %}
			}
		});

		// WARNING! Don't ever move this variable around. It's being accessed
		// from multiple locations and it's going to blow up if touched!
		var vocabs = JSON.parse("{{ vocab_selection|escapejs }}");

		function getSelectedVocabId() {
			var i, vocab_id = Number(CookieManager.getItem("vocab_id") || undefined);
			for (i in vocabs) {
				if (vocab_id === vocabs[i].id) {
					// ID is valid
					return vocab_id;
				}
			}
		}

		// Vocabulary selection
		function getVocabSelection(id) {
			var $vocabSelect = $('<select id="' + id + '"></select>');
			var optiongroups = {
				"own": $('<optgroup label="eigene Thesauri"/>'),
				"other": $('<optgroup label="öffentliche Thesauri"/>')
			};
			var i, $option, selected_id = getSelectedVocabId();
			for (i = 0; i < vocabs.length; i++) {
				$option = $("<option value='" + vocabs[i].id + "' data-url='" + vocabs[i].tree_url + "'" + ((selected_id === vocabs[i].id)?" selected":"") + ">" + vocabs[i].name + ", V" + vocabs[i].version + " (" + vocabs[i].provider + ")" + ((vocabs[i].modifiable)?" [read/write]":" [read-only]") + "</option>");
				$option.data("vocab", vocabs[i]);
				optiongroups[vocabs[i].owning_state].append($option);
			}
			var optiongroup;
			for (optiongroup in optiongroups) {
				if (0 < optiongroups[optiongroup].children().length) {
					$vocabSelect.append(optiongroups[optiongroup]);
				}
			}
			return $vocabSelect;
		}

		// Save tree
		function saveTree(done, fail, always) {
			$.ajax({
				"url": "{% url 'TM:tree_modify' %}",
				"data": {
					"tree": JSON.stringify(traverseTree(rootForSaving)),
					"vocab_id": vocab_id,
				},
				"type": "POST",
				"dataType" : "json",
			}).done(done).fail(fail).always(always);
		}

		// Set status
		function setStatus($statusDiv, message, progressValue=false, failed=false) {
			var $progressBar, $progressLabel;
			if (0 === $statusDiv.children().length) {
				$progressBar = $("<div id='progressbar' />").appendTo($statusDiv);
				$progressLabel = $("<div class='progress-label' />").appendTo($progressBar);
				$progressBar.progressbar();
			} else {
				$progressBar = $statusDiv.find("div#progressbar");
				$progressLabel = $progressBar.find("div.progress-label");
				clearElementTimeout($progressBar);
			}
			$progressLabel.text(message);
			$progressBar.progressbar("value", progressValue);
			$progressBar.find(".ui-progressBar-value").toggleClass("failed", failed);
			if (progressValue >= 100) {
				$progressBar.data("timer", setTimeout(function () {
					$progressBar.removeData("timer");
					$statusDiv.empty();
				}, 5000));
			}
		}

		// Switch for control element activation and deactivation
		function controlElementActivation(element) {
			element.prop("disabled", true);
			var elementSwitch = $.Deferred();
			if (element.data("deferredActivation")) {
				element.data("deferredActivation").push(elementSwitch.promise());
			} else {
				var reseservedForFuturePromises = [];
				var chained_promises = $.when(elementSwitch.promise());
				chained_promises = chained_promises.pipe(function () {
					return $.when.apply($, reseservedForFuturePromises);
				});
				chained_promises.then(function () {
					element.prop("disabled", false);
					element.removeData("deferredActivation");
				});
				element.data("deferredActivation", reseservedForFuturePromises);
			}
			return elementSwitch;
		}

		// Set text for an element with a timeout
		function setTextWithTimeout(element, text, timeout, callback) {
			clearElementTimeout(element);
			element.text(text);
			element.data("timer", setTimeout(function () {
				element.removeData("timer");
				element.empty();
				if ("function" === typeof(callback)) { callback(); }
			}, timeout || 5000));
		}

		// Clear timeout for element
		function clearElementTimeout(element) {
			if (element.data("timer")) {
				clearTimeout(element.data("timer"));
				element.removeData("timer");
			}
		}
	</script>
	{% csrf_token %}
</head>
<body>
	<div id="titlebar">
		<div class="control_row">
			<!-- top row -->
			<div id="vocab_section"></div>
			<div id="auth">
				{% if user.is_authenticated %}
				<form method="POST" action="{% url 'logout' %}">
					<input type="hidden" name="next" value="{% url 'TM:tree' %}" />
					{% csrf_token %}
					<p>{{ user.username }}</p>
					<input type="submit" class="button button-small button-salmon" value="Logout" />
				</form>
				{% else %}
				<p>Gast</p>
				<a href="{% url 'login' %}?next={% url 'TM:tree' %}" class="button button-small button-salmon">Login</a>
				{% endif %}
			</div>
			<div id="help">
				<a href="{% url 'TM:help' %}" target="_blank" class="button button-small button-green">Hilfe</a>
			</div>
		</div>
		<div class="control_row">
			<!-- bottom row -->
			<div id="panel">
			</div>
			<div id="search_section"></div>
		</div>
	</div>
	<div id="tree-container"></div>
</body>
</html>
